import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;

public class Espresso extends Applet {
  final String lonely = "I'm a lonely applet";
  String drawText = lonely;
  // Nimmt die Instanz des anderen Applets auf
  Applet applet;   
  // Name des Applets
  String appletName;       
  // Namen des anderen Applets 
  String otherAppletName;  
  // Anzahl der Aufrufe von TouchMe
  int timestouched = 0;    
  boolean appletfound = false;

  public void init() {
    // Name des eigenen und des anderen Applets
    // als Parameter einlesen
    appletName = getParameter("NAME"); 
    otherAppletName = getParameter("otherApplet");
    enableEvents(AWTEvent.MOUSE_EVENT_MASK);
  }

  public void paint(Graphics g) {
    // Ausgabe des Textes
    g.drawString("My name is "+appletName, 30, 30);
    g.drawString(drawText, 30, 50);
  }

  public void processMouseEvent(MouseEvent e) {
    if (e.getID() == MouseEvent.MOUSE_CLICKED) {
      // Prfen, ob schon ein Applet gefunden wurde
      if (applet == null) 
	// Versuch das andere Applet direkt ber seinen 
	// Namen anzusprechen
	applet = getAppletContext().getApplet(otherAppletName);
      if (applet == null) {
	// Abfragen aller Applets auf der Seite
	Enumeration applets = getAppletContext().getApplets();
	// Suchen des zu kontaktierenden Applets in der Liste
	while(applets.hasMoreElements() && (! appletfound)) {
	  applet = (Applet)applets.nextElement();
	  if (applet instanceof Coffee)
	    appletfound = true;
	}
      } 
      else  
	appletfound = true;
      // Wenn das Applet gefunden wurde, 
      // wird dessen Methode TouchMe aufgerufen.
      if (appletfound) 
	((Coffee)applet).touchMe(appletName);
    }
    super.processMouseEvent(e);
  }

  public void touchMe(String name) {
    // Wird von anderen Applets aufgerufen,
    // gibt den bergebenen Namen des anderen Applets
    // aus und zhlt die Anzahl der Aufrufe mit
    timestouched++;
    drawText = name + " touched me " 
                           + timestouched + " times !";
    repaint();
  }
}




